#include <linux/config.h>
#include <linux/types.h>
#include <linux/string.h>
#include <linux/kernel.h>
#include <linux/module.h>

MODULE_AUTHOR("Marco Lamberto");

//
unsigned long net_random(void);


void
m_memcpy(char *dest, char *src, int len)
{
	while (len--)
		*(dest + len) = *(src + len);
}


int
init_module()
{
	int i;
	void (*func)(void) = net_random;
	char buf[] = {
		0, 0, 0, 0,
	 	0, 0, 0, 0,
	 	0, 0, 0, 0,
	 	0, 0, 0, 0,
	};

	printk(KERN_INFO "memdumper init\n");
	printk(KERN_INFO "memdumper addr: %p\n", func);

	for (i = 0; i < sizeof(buf) * 2; i++) {
		printk(KERN_INFO "memdumper data: %p %08X\n",
			func + i * 4, *(int *)(func + i * 4));
	}
	printk(KERN_INFO "memdumper reading\n");
	//m_memcpy(buf, func, sizeof(buf));
	printk(KERN_INFO "memdumper overwriting\n");
	m_memcpy(func, buf, sizeof(buf));
	return 0;
}

void
cleanup_module()
{
	printk(KERN_INFO "memdumper done\n");
}

